package com.jojubanking.boot.module.system.service.dztype;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import java.util.*;
import com.jojubanking.boot.module.system.controller.admin.dztype.vo.*;
import com.jojubanking.boot.module.system.dal.dataobject.dztype.DzTypeDO;
import com.jojubanking.boot.framework.common.pojo.PageResult;

import com.jojubanking.boot.module.system.convert.dztype.DzTypeConvert;
import com.jojubanking.boot.module.system.dal.mysql.dztype.DzTypeMapper;

import static com.jojubanking.boot.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.jojubanking.boot.module.system.enums.ErrorCodeConstants.*;

/**
 * 导诊类型 Service 实现类
 *
 * @author admin
 */
@Service
@Validated
public class DzTypeServiceImpl implements DzTypeService {

    @Resource
    private DzTypeMapper dzTypeMapper;

    @Override
    public Integer createDzType(DzTypeCreateReqVO createReqVO) {
        // 插入
        DzTypeDO dzType = DzTypeConvert.INSTANCE.convert(createReqVO);
        dzTypeMapper.insert(dzType);
        // 返回
        return dzType.getId();
    }

    @Override
    public void updateDzType(DzTypeUpdateReqVO updateReqVO) {
        // 校验存在
        this.validateDzTypeExists(updateReqVO.getId());
        // 更新
        DzTypeDO updateObj = DzTypeConvert.INSTANCE.convert(updateReqVO);
        dzTypeMapper.updateById(updateObj);
    }

    @Override
    public void deleteDzType(Integer id) {
        // 校验存在
        this.validateDzTypeExists(id);
        // 删除
        dzTypeMapper.deleteById(id);
    }

    private void validateDzTypeExists(Integer id) {
        if (dzTypeMapper.selectById(id) == null) {
            throw exception(DZ_TYPE_NOT_EXISTS);
        }
    }

    @Override
    public DzTypeDO getDzType(Integer id) {
        return dzTypeMapper.selectById(id);
    }

    @Override
    public List<DzTypeDO> getDzTypeList(Collection<Integer> ids) {
        return dzTypeMapper.selectBatchIds(ids);
    }

    @Override
    public PageResult<DzTypeDO> getDzTypePageGroup(DzTypePageReqVO pageReqVO) {
        return dzTypeMapper.selectPage1(pageReqVO);
    }
    public PageResult<DzTypeDO> getDzTypeGroup(DzTypePageReqVO pageReqVO) {
        return dzTypeMapper.selectPage2(pageReqVO);
    }

    @Override
    public PageResult<DzTypeDO> getDzTypePage(DzTypePageReqVO pageReqVO) {
        return dzTypeMapper.selectPage(pageReqVO);
    }

    public List<DzTypeDO> getDzTypeList(DzTypeExportReqVO exportReqVO) {
        return dzTypeMapper.selectList(exportReqVO);
    }

}
